

function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var framerMotion = require('framer-motion');

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(n);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var Item = function Item(_ref) {
  var item = _ref.item,
      numberInQueue = _ref.numberInQueue,
      row = _ref.row,
      yDistanceToTop = _ref.yDistanceToTop,
      _ref$yVariation = _ref.yVariation,
      yVariation = _ref$yVariation === void 0 ? 30 : _ref$yVariation,
      _ref$yDuration = _ref.yDuration,
      yDuration = _ref$yDuration === void 0 ? 3 : _ref$yDuration,
      _ref$xDuration = _ref.xDuration,
      xDuration = _ref$xDuration === void 0 ? 20 : _ref$xDuration,
      _ref$xDistanceBetween = _ref.xDistanceBetweenItems,
      xDistanceBetweenItems = _ref$xDistanceBetween === void 0 ? 0 : _ref$xDistanceBetween,
      rowNumber = _ref.rowNumber,
      className = _ref.className,
      Component = _ref.Component,
      containerWidth = _ref.containerWidth;
  // Window width
  var windowWidth = 0;
  var BASELINE_WINDOW_WIDTH = 1920;
  React.useEffect(function () {
    windowWidth = window.innerWidth;
  }, []); // Element width

  var _useState = React.useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      itemWidth = _useState2[0],
      setItemWidth = _useState2[1];

  var measuredRef = React.useCallback(function (node) {
    if (node !== null) {
      setItemWidth(node.getBoundingClientRect().width);
    }
  }); // Default to window width

  containerWidth = containerWidth || windowWidth; // Element width including xDistanceBetweenItems

  var itemWithGapWidth = itemWidth + xDistanceBetweenItems; // Is row on an even number

  var isEvenRow = rowNumber % 2 === 0; // Total distance a testimonial needs to travel, in px

  var distanceToTravel = containerWidth + itemWidth + itemWithGapWidth / 2 + xDistanceBetweenItems / 2; // Speed modifier

  var SPEED = 1; // Time it takes to complete 1 loop on the x axis

  var X_DURATION = distanceToTravel / BASELINE_WINDOW_WIDTH * (xDuration / SPEED); // Time it takes to complete 1 loop on the y axis

  var Y_DURATION = yDuration / SPEED; // How many seconds it takes to travel a pixel

  var secPerPx = X_DURATION / distanceToTravel;
  var initial = {
    position: 'absolute',
    // change the "start" point depending on whether it's odd/even
    // odd rows start further to the right to offset the entire row slightly
    x: "calc(".concat(containerWidth, "px + ").concat(isEvenRow ? 0 : itemWithGapWidth / 2, "px)"),
    y: yDistanceToTop + 'px'
  };
  var animate = {
    // change the "end" point depending on whether it's odd/even row
    // odd rows "end" point is closer as they start an equal distance further away
    x: "-".concat(itemWidth + (isEvenRow ? itemWithGapWidth / 2 : 0), "px"),
    y: yDistanceToTop + yVariation + 'px'
  };
  var repeatDelay = secPerPx * itemWithGapWidth * row.items.length - X_DURATION;
  var transition = {
    x: {
      duration: X_DURATION,
      ease: 'linear',
      delay: secPerPx * itemWithGapWidth * numberInQueue,
      loop: Infinity,
      repeatDelay: repeatDelay < 0 ? 0 : repeatDelay
    },
    y: {
      duration: Y_DURATION,
      ease: 'easeInOut',
      delay: Math.random() * (yDuration / 2),
      yoyo: Infinity
    }
  };
  var containerClassName;

  if (typeof className === 'string') {
    containerClassName = className;
  } else if (typeof className === 'function') {
    containerClassName = className({
      rowNumber: rowNumber,
      numberInQueue: numberInQueue
    });
  }

  return /*#__PURE__*/React__default.createElement(framerMotion.motion.div, {
    style: initial,
    animate: animate,
    transition: transition,
    className: className ? containerClassName : null,
    ref: measuredRef
  }, /*#__PURE__*/React__default.createElement(Component, item));
};

Item.propTypes = {
  item: PropTypes.any.isRequired,
  numberInQueue: PropTypes.number.isRequired,
  rowNumber: PropTypes.number.isRequired,
  row: PropTypes.object.isRequired,
  yDistanceToTop: PropTypes.number.isRequired,
  yVariation: PropTypes.number,
  yDuration: PropTypes.number,
  Component: PropTypes.any.isRequired,
  className: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
  containerWidth: PropTypes.number
};

var Row = function Row(_ref) {
  var row = _ref.row,
      reactKey = _ref.reactKey,
      props = _objectWithoutProperties(_ref, ["row", "reactKey"]);

  return row.items.map(function (item, index) {
    return /*#__PURE__*/React__default.createElement(Item, _extends({
      item: item,
      numberInQueue: index,
      yDistanceToTop: row.yDistanceToTop,
      key: item[reactKey],
      row: row
    }, props));
  });
};

Row.propTypes = {
  row: PropTypes.shape({
    items: PropTypes.array.isRequired,
    yDistanceToTop: PropTypes.number.isRequired
  }).isRequired,
  reactKey: PropTypes.string.isRequired
};

var River = function River(_ref) {
  var allItems = _ref.allItems,
      _ref$amountOfRows = _ref.amountOfRows,
      amountOfRows = _ref$amountOfRows === void 0 ? 1 : _ref$amountOfRows,
      _ref$yDistanceBetween = _ref.yDistanceBetweenRows,
      yDistanceBetweenRows = _ref$yDistanceBetween === void 0 ? 50 : _ref$yDistanceBetween,
      props = _objectWithoutProperties(_ref, ["allItems", "amountOfRows", "yDistanceBetweenRows"]);

  var counter = 0;
  var rows = allItems.reduce(function (accumulator, currentItem) {
    // If no array exists already, create one
    if (!accumulator[counter]) {
      accumulator[counter] = [];
    } // Add current item to it's row


    accumulator[counter].push(currentItem); // Increase/reset counter

    if (counter + 1 === amountOfRows) {
      counter = 0;
    } else {
      counter++;
    }

    return accumulator;
  }, []);
  var rowsWithDistance = rows.map(function (row, idx) {
    return {
      items: row,
      yDistanceToTop: idx * yDistanceBetweenRows
    };
  }); // Element width

  var _useState = React.useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      itemWidth = _useState2[0],
      setItemWidth = _useState2[1];

  var measuredRef = React.useCallback(function (node) {
    if (node !== null) {
      setItemWidth(node.getBoundingClientRect().width);
    }
  });
  return /*#__PURE__*/React__default.createElement("section", {
    style: {
      width: '100%',
      height: '100%',
      overflow: 'hidden',
      position: 'relative'
    },
    ref: measuredRef
  }, rowsWithDistance.map(function (row, index) {
    return /*#__PURE__*/React__default.createElement(Row, _extends({
      row: row,
      yDistanceBetweenRows: yDistanceBetweenRows,
      key: row.items[0][props.reactKey],
      rowNumber: index,
      containerWidth: itemWidth
    }, props));
  }));
};

River.propTypes = {
  allItems: PropTypes.array.isRequired,
  reactKey: PropTypes.string.isRequired,
  Component: PropTypes.any.isRequired,
  amountOfRows: PropTypes.number,
  yDistanceBetweenRows: PropTypes.number
};

exports.default = River;
//# sourceMappingURL=index.js.map
